#include "ti86asm.inc"
#include "asm86.h"
Texte	=	_cmdShadow
Reponse =	_textShadow
.org _asm_exec_ram
	nop							; pour le shell
	jp Depart
.dw 0
.dw Title
Title:	.db "Chating with the Ir_link by A.MERCIER",0
;===================================================================================
Depart:
	call _flushallmenus
	call _clrLCD
	res appTextSave,(iy+appflags)
	call _runindicoff
	ld a,$C0
	out (7),a
	xor a						; <=> ld a,0
	ld (txtgl),a				; texte du graphe =0
	ld (txtuserl),a				; texte de l'cran principal =0
	ld (ligne),a				; ligne 0 (pour le scrolling)
	ld (nbrscroll),a			; on a pas encore fait de scrolling pour la reponse
	inc a
	ld (mode),a					; 1er mode : l'cran principal
	ld hl,Flags					; mes flags
	set 1,(hl)					; il y a quelque chose dans le graphe (=1)
	set 2,(hl)					; on a pas appuy sur les flches (=1)
	res 3,(hl)					; on n'est pas en fin de ligne
	bit graphdraw,(iy+graphflags)
	jr nz,Dsuite
	res 1,(hl)					; il n'y a rien dans le graph (=0)
Dsuite:
	call _homeup				; curseur en haut de l'cran
	call _newline				; dcale d'1 ligne
	ld hl,Presentation			; cran de prsentation
	call _puts					; affiche la 1re ligne
	call _newline				; dcale d'1 ligne
	call _puts					; affiche la 2me ligne
	call _newline				; dcale d'1 ligne
	call _puts					; affiche la 3me ligne
	ld de,$2114
	ld (_penCol),de				; $14->x,$21->y, (20,33)
	call _vputs					; affiche la 4me ligne petite police
	ld de,$385A
	ld (_penCol),de				; $5a->x,$38->y, (90,56)
	call _vputs					; affiche la 5me ligne petite police
	call _getkey				; attend 1 touche
	cp kExit
	jp z,Done
	call _clrLCD
	call _homeup				; curseur en haut de l'cran
	ld hl,comptxt
	call _puts					; affiche la 1re ligne
	call _newline				; dcale d'1 ligne
	call _puts					; affiche la 2me ligne
	call _newline				; dcale d'1 ligne
	call _puts					; affiche la 3me ligne
	call _newline				; dcale d'1 ligne
	call _puts					; affiche la 4me ligne
	call _newline				; dcale d'1 ligne
	call _puts					; affiche la 5me ligne
	ld hl,comp
	ld (hl),0
Dkeyloop:
	push hl
	call _getkey				; attend 1 touche
	pop hl
	cp kExit
	jp z,Done
	cp kF1
	jr z,IrTerm
	cp kF2
	jr z,IrChat
	cp kF3
	jr z,Autres
	jr Dkeyloop
Autres:
	inc (hl)
IrChat:
	inc (hl)
IrTerm:
	call _clrScrn				; efface l'cran
	call _homeup				; curseur en haut de l'cran
	call Affichecurseur
;===================================================================================
;===================================================================================
Text:							; texte dans l'cran principal
	ld a,$C0
	out (7),a					; sorties hautes (W1, R1)
	in a,(7)
	and 3
	cp 3						; teste si on reoit quelque chose
	jp nz,Receive				; oui, alors on le prend
	call GET_KEY				; a= une ventuelle touche presse
	or a						; non, on regarde si on a press 1 touche
	jp z,Text					; pas de touche, on recommence
	cp K_EXIT					; exit ?
	jp z,Done					; oui, on quitte
	cp K_GRAPH					; grah ?
	jp z,LCDgraph				; oui, on change de mode
	cp K_DEL					; del ?
	jp z,DEL					; oui, on efface le caractre
	cp K_F5						; F5 ?
	jp z,sendtexte				; oui, on envoie le texte
	cp K_ENTER					; enter ?
	jp z,Newline				; oui, on saute 1 ligne
	cp K_ALPHA					; alpha ?
	jp z,Alpha					; oui, on change les lettres
	cp K_SECOND					; 2nd ?
	jp z,Set0					; oui, valide les caractres divers
	cp K_CLEAR					; clear ?
	jp z,effaceLCD1				; oui, on efface tout l'cran
	cp K_DOWN					; bas ?
	jp z,ReponseBas				; oui, on scroll la rponse d'1 ligne vers le bas
	cp K_UP						; haut ?
	jp z,ReponseHaut			; oui, on scroll la rponse d'1 ligne vers le haut
	call CheckLetter			; sinon, on regarde si a correspond  un caractre
	cp 0						; =0 ?
	jp z,Text					; oui, on retourne (rien  faire)
	ld c,a						; copie le caractre dans c
	ld a,(txtuserl)				; longueur du texte
	cp 167						; =167 ?
	jp z,Text					; oui, on ne fait rien
	ld a,c						; on reprend le caractre
	call _putc					; et on l'affiche
	ld d,a						; copie le caractre dans d
	ld hl,Texte
	ld b,0
	ld a,(txtuserl)
	ld c,a
	add hl,bc					; hl = emplacement ou l'on stock le caractre
	ld (hl),d
	ld hl,txtuserl				; hl = position o on mmorise la longueur du texte
	inc (hl)					; longueur +1
	call Affichecurseur			; on raffiche le curseur
	ld a,(_curCol)
	cp 20						; est-ce la derniere position ?
	jp z,Newline				; oui, on saute une ligne
	jp Text						; on retourne
;-----------------------------------------------------------------------------------
Newline:
	ld d,$fe
	ld hl,Texte
	ld b,0
	ld a,(txtuserl)
	ld c,a
	add hl,bc
	ld (hl),d
	ld hl,txtuserl
	inc (hl)
	ld a,(ligne)				; on met  jour tous les compteurs
	cp 3
	jp z,Scrolldown				; a-t-on besoin de faire un scrolling ?
	ld a,' '
	call _putmap				; efface le curseur
	call _newline				; nouvelle ligne
	ld hl,ligne
	inc (hl)
	call Affichecurseur
	jp Text
;===================================================================================
;===================================================================================
Graph1:
	call GCurseur
Graph:
	ld a,$C0					;
	out (7),a					; sorties haute (W1, R1)
	in a,(7)					;
	and 3						;
	cp 3						; teste si on reoit quelque chose
	jp nz,Receive				; oui, alors on le prend
	call GET_KEY				;
	or a						; non, on regarde si on a press 1 touche
	jp z,Graph					; pas de touche, on recommence
	cp K_EXIT					; est-ce exit ?
	jp z,Done					; oui, on quitte
	cp K_GRAPH
	jp z,LCDmain
	cp K_ENTER
	jp z,Line
	cp K_F4
	jp z,Sendallscreen
	cp K_F5
	jp z,SendtextG
	cp K_ALPHA					; est-ce alpha ?
	jp z,Alpha					; oui, on change les lettres
	cp K_SECOND
	jp z,Set0
	cp K_CLEAR
	jp z,Effgraph
	cp K_LEFT
	jp z,agauche
	cp K_RIGHT
	jp z,adroite
	cp K_UP
	jp z,enhaut
	cp K_DOWN
	jp z,enbas
	call CheckLetter
	cp 0
	jp z,Graph					; si =  0 on retourne (rien  faire)
	ld c,a
	ld a,(txtgl)
	cp 167
	jp z,Graph					; max de caracteres autoriss
	ld a,c
	push af
	ld a,(curX)
	ld (_penCol),a
	ld a,(curY)
	ld c,a
	ld a,63
	sub c
	ld (_penRow),a				; on enregistre & convertit les coordonnees
	push hl
	ld hl,Flags
	bit 2,(hl)
	call nz,Coord				; test si on doit les memoriser
	pop hl
	ld b,1
	set textwrite,(iy+new_grf_flgs)
	call _vputsn
	res textwrite,(iy+new_grf_flgs)
	ld a,(_penCol)
	ld (curX),a
	ld a,(_penRow)
	ld c,a
	ld a,63
	sub c
	ld (curY),a						; on a mis a jour les coordonnees
	ld a,(txtgl)
	ld c,a
	ld b,0
	ld hl,textg
	add hl,bc
	pop af
	ld (hl),a
	ld hl,txtgl
	inc (hl)
	ld hl,Flags
	set 1,(hl)
	jp Graph1
Coord:
	res 2,(hl)						; on commence 1 nelle chaine
	ld a,(txtgl)
	ld c,a
	ld b,0
	ld hl,textg
	add hl,bc
	ld (hl),0
	inc hl
	ld a,(curY)						; y->
	ld (hl),a
	inc hl
	ld a,(curX)						; x->
	ld (hl),a
	ld hl,txtgl
	inc (hl)
	inc (hl)
	inc (hl)						; incre de 3 pr long du texte
	ret
;===================================================================================
;===================================================================================
Done:
	set appTextSave,(iy+appflags)
	set textScrolled,(iy+textflags)
	set appAutoScroll,(iy+appflags)
	call _clrScrn
	call _homeup
	jp 409Ch
;===================================================================================
;===================================================================================
#include "routines.asm"
#include "txtrt.asm"
#include "grfrt.asm"
#include "envoyer.asm"
#include "recevoir.asm"
;***********************************************************************************
curX:		.db 63
curY:		.db 32
pt1x:		.db 0
pt1y:		.db 0
pt2x:		.db 0
pt2y:		.db 0
ptR:		.db 0,0,0,0
mode:		.db 1
txtuserl:	.db 0
curseur:	.db 223,0
ligne:		.db 0
nbrscroll:	.db 0
reponsel:	.db 0
RnbrScroll:	.db 0
Rnbrligne:	.db 0
txtgl:		.db 0
tps:		.db 0
comp:		.db 0
Flags:		.db %00000000
; 1: graph blanc ; 2:les fleches ;3: fin de ligne
; 4: ; 5: ; 6: ; 7: ; 0:
ToucheLettre:
 .db	$28,$2A,$11,$19,$21,$0A,$12,$1A,$22,$0B,$13,$1B,$23,$2B,$0C
 .db	$14,$1C,$24,$2C,$0D,$15,$1D,$25,$2D,$0E,$16,$1E,$26,$2E
Touches:
 .db	$28,$11,$2C,$2A,$19,$0E,$15,$1D,$2B,$0D,$0C,$0B
 .db	$0A,$14,$1C,$24,$13,$1B,$23,$12,$1A,$22,$21
LettreMaj:
 .db	"ABCDEFGHIJKLMNOPQRSTUVWXYZ ",61,"x"
LettreMin:
 .db	"abcdefghijklmnopqrstuvwxyz ",61,"x"
caracts:
 .db	"0123456789+-*/,()^.",28,18,26,"x"
Effmess:
 .db	"  Clear the screen ? "
 .db	"F1 : Yes (top)       "
 .db	"F2 : Yes (bottom)    ",0
Effmess1:
 .db	"  Clear the screen ? "
 .db	"F1 : Yes             ",0
Presentation:
 .db	"     IrTerm v3.1",0
 .db	"         by",0
 .db	"   Antoine MERCIER",0
 .db	"a.mercier@caramail.com",0
 .db	"press a key",0
comptxt:
 .db	"IrTerm will work with",0
 .db	"F1: IrTerm",0
 .db	"F2: IrChat",0
 .db	"F3: Rterm,fTerm",0
textg:
 .db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
.end
