sendtexte:
	ld a,(txtuserl)
	or a
	jp z,Text					; vrifie si qqch  envoyer
	ld b,a
	ld a,' '
	call _putmap				; efface le curseur
	ld a,(comp)
	cp 0
	jr nz,sendautre
	ld a,$F8
	call PutByte				; test pour le pic
	jp nz,ilnyapasdePIC
	ld a,$F2
	call PutByte				; on envoie alors du texte
	ld a,$FB
	call PutByte				;  partir d'une 86
	ld a,b
	call PutByte				; longueur du texte
sendautre:
	ld hl,Texte
	call Sendcaractere
	ld a,(comp)
	cp 0
	jp z,FinLiaison
	cp 2
	jr z,sendasuite
	ld a,$FE
	call PutByte				; <enter> pour IrChat
sendasuite:
	jp effaceLCD
sendline:
	ld a,$F8
	call PutByte				; test pour le pic
	jp nz,ilnyapasdePIC
	ld a,$F0
	call PutByte				; on envoie alors 1 ligne
	ld a,$FB
	call PutByte				;  partir d'une 86
	ld a,4
	call PutByte				; 4 coordonnes
	ld b,4
	ld hl,pt1x
	call Sendcaractere
	call FinLiaison
	ret
Sendallscreen:
	ld hl,Flags
	bit 1,(hl)
	jp z,Graph
	ld a,$F8
	call PutByte				; test pour le pic
	jr nz,ilnyapasdePIC
	ld a,$F3
	call PutByte				; on envoie alors tout l'cran
	ld a,$FB
	call PutByte				;  partir d'une 86
	ld hl,$C9FA
	ld bc,$0400
SASloop:
	ld a,(hl)
	call PutByte
	inc hl
	dec bc
	ld a,c
	or b
	jr nz,SASloop
	call FinLiaison
	jp Graph
SendtextG:
	ld a,(txtgl)
	or a
	jp z,Graph				; vrifie si qqch  envoyer
	ld b,a
	ld a,$F8
	call PutByte				; test pour le pic
	jp nz,ilnyapasdePIC
	ld a,$F1
	call PutByte				; on envoie alors du texte ds graph
	ld a,$FB
	call PutByte				;  partir d'une 86
	ld a,b
	call PutByte				; longueur du texte
	ld hl,textg
	call Sendcaractere			; c'est bon, on l'envoie maintenant !!!
	call FinLiaison
	xor a
	ld (txtgl),a
	jp Graph
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
FinLiaison:
	ld a,$F9
	call PutByte				; fin de la transmission
	ld bc,$FFFF
reponse:
	in a,(7)
	and 3
	cp 3						; teste si on reoit quelque chose
	jr nz,Ssuite
	dec bc
	ld a,b
	or c
	jr nz,reponse
	jr erreurinsend
Ssuite:
	call GetByte				; oui, alors on le prend
	cp $F6
	jr nz,erreurinsend			; si different de $F6 -> il y a eu 1 erreur
;pas d'erreur:
	ld a,(mode)
	cp 1
	jp z,effaceLCD
	ret
ilnyapasdePIC:
	ld de,SendWrong1
	jr Message
erreurinsend:					;pb de transmission
	ld de,SendWrong2
;	jr Message
Message:						; entre : de = message
	ld a,$C0
	out (7),a
	res 2,(iy+12)
	push de
	call _clrLCD
	pop hl
	ld de,$0001
	ld (_curRow),de
	call _puts
Mloop:
	call GET_KEY
	or a
	jr z,Mloop
	ld a,(mode)
	cp 1
	jp z,LCDmain
	jp LCDgraph
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
Sendcaractere:
	ld a,(hl)
	call PutByte
	inc hl
	djnz Sendcaractere
	ret
;-----------------------------------------------------------------------------------
; Thanks for Sami Khawam (sKhawam@bigfoot.com) for his send routine.
;-----------------------------------------------------------------------------------
PutByte:
	call _runindicon
	push bc
	ld c,a
	ld b,8						; 8 Bits
PBNextBit:
	ld a,$C0
	out (7),a
Cont:
	rr c
	jr nc,PBSendZero
PBSendOne:
	ld a,$E8
	jr PBOutputval
PBSendZero:
	ld a,$D4
PBOutputval:
	out (7),a
	ld de,$FFFF					; For time-out
PBWaitforW0andR0:
	in a,(7)
	and 3
	jr Z,PBContinue
	in a,(7)
	and 3
	jr Z,PBContinue
	dec de
	ld a,d
	or e
	jr nz,PBWaitforW0andR0
	or 3
	jr PBEnd					; If error return.
PBContinue:
	ld a,$C0
	out (7),a
	ld de,$FFFF					; Reload time-out
PBWaitforW1andR1:
	dec de
	ld a,d
	or e
	jr z,PBEnd
	in a,(7)
	and 3
	cp 3
	jr nz,PBWaitforW1andR1
	djnz PBNextBit
	ld de,$06FF					; Small delay
PBEW:  
	dec de
	ld a,d
	or e
	jr nz,PBEW
PBEnd:
	pop bc
	call _runindicoff
	ret
SendWrong2:
 .db	"  ****************** "
 .db	"  *  transmission  * "
 .db	"  *     failed     * "
 .db	"  *                * "
 .db	"  * (not received) * "
 .db	"  ****************** ",0
SendWrong1:
 .db	"  *****************  "
 .db	"  *  transmission *  "
 .db	"  *     failed    *  "
 .db	"  *   (PIC not    *  "
 .db	"  *   connected)  *  "
 .db	"  *****************  ",0
