;-------------------------------------------------------------------------
;Affiche une chaine de caracteres
;-------------------------------------------------------------------------
AfficheTxt:
	res appTextSave,(iy+appflags)
	res textScrolled,(iy+textflags)
	res appAutoScroll,(iy+appflags)
	ld b,a
	cp 0
	jr z,endbtdetxt
	ld a,$FE
ATloop1:
	cp (hl)
	inc hl
	jr nz,ATloop1
	djnz ATloop1
endbtdetxt:
	xor a
	ld (_curCol),a
	ld b,c
	ld d,0
	inc e
ATloop2:
	dec e
	ld a,e
	cp 0
	ret z
	ld a,(hl)
	inc hl
	cp $FE
	jr z,alaligne
	call _putc
	inc d
	ld a,21
	cp d
	jr nz,ATloop2
	xor a
	ld d,a
	cp b
	ret z
	jr ATloop2
alaligne:
	call _newline
	djnz ATloop2
	ret
;-------------------------------------------------------------------------
; affiche le curseur et la ligne horizontale
;-------------------------------------------------------------------------
Affichecurseur:
	res appTextSave,(iy+appflags)
	ld a,(curseur)
	call _putmap
	ld hl,$FDF0
	ld b,16
Cloop:
	ld (hl),$FF
	inc hl
	djnz Cloop
	ret
;-------------------------------------------------------------------------
; Efface 1/2 cran
;-------------------------------------------------------------------------
Eff1demiLCD:
	ld bc,$01F0
effLoop:
	ld (hl),0
	inc hl
	dec bc
	ld a,b
	or c
	jr nz,effLoop
	ret
;-------------------------------------------------------------------------
; changement d'cran
;-------------------------------------------------------------------------
LCDmain:
	call ecranprincipal
	jp Text
LCDgraph:
	call ecrangraph
	jp Graph
ecrangraph:
	ld a,2
	ld (mode),a
;	ld a,' '
;	call _putmap
	ld  hl,$c9fa				; hl = source
	ld  de,$fc00				; de = destination
	ld  bc,1024					; bc = nombre d'octets  changer
	ldir						; on a donc  l'cran le graph
	call GCurseur
	ret
ecranprincipal:
	ld a,1
	ld (mode),a
	call _clrLCD
	ld hl,Texte					; texte  afficher
	ld c,4						; nombre de lignes
	xor a
	ld (_curRow),a				;  partir de la ligne 0
	ld a,(txtuserl)
	ld e,a
	ld a,(nbrscroll)
	call AfficheTxt
	ld hl,(_curRow)
	push hl
	ld hl,Reponse				; texte  afficher
	ld c,4						; nombre de lignes
	ld a,4
	ld (_curRow),a				;  partir de la ligne 5
	ld a,(reponsel)
	ld e,a
	ld a,0
	call AfficheTxt
	pop hl
	ld (_curRow),hl
	call Affichecurseur
	ret
;-------------------------------------------------------------------------
; changement de lettres (maj, min, spciales)
;-------------------------------------------------------------------------
Alpha:
	ld a,(curseur)
	cp 225
	jr z,seta
setA:
	ld a,225
	jr Asuite
seta:
	ld a,226
	jr Asuite
Set0:
	ld a,223
Asuite:
	ld (curseur),a
	ld a,(mode)
	cp 1
	call z,Affichecurseur
	cp 2
	call z,Gaffcurs
	ld a,(mode)
	cp 1
	jp Text
	jp Graph1
;-------------------------------------------------------------------------
; recherche de la lettre correspondant  la touche presse
;-------------------------------------------------------------------------
CheckLetter:
	push af
	ld a,(curseur)
	cp 223
	jr z,Norm					; caracteres
	ld hl,ToucheLettre
	ld bc,$001D
	cp 225
	jr z,Maj					; les lettres sont en majuscules
	cp 226
	jr z,Min					; les lettres sont en minuscules
	ret
Maj:
	ld de,LettreMaj
	jr CLsuite
Min:
	ld de,LettreMin
	jr CLsuite
Norm:
	ld hl,Touches
	ld bc,$0017
	ld de,caracts
CLsuite:
	pop af
	cpir						; on les compare avec la touche presse
	ld a,c						; mmorise le rsultat dans a
	ret nz						; si elle ne correspond  rien c'est fini
	ex de,hl
	add hl,bc					; on additionne avec notre rsultat
	ld a,(hl)					; stock le caractre dans a
	ret
